extends Node


export(PackedScene) var scene_andouille
var score


func _ready():
	$PetitBoudin.hide()
	randomize()


func demarrer_jeu():
	score = 0
	$InterfaceJeu.maj_score(0)
	$InterfaceJeu/Score.margin_top = 0
	$InterfaceJeu/Score.show()
	$PetitBoudin.demarrer($PBPositionDepart.position, $PBPositionDepart.rotation)
	$AndouilleTimer.start()


func fin_du_jeu():
	$AndouilleTimer.stop()
	get_tree().call_group("groupe_andouilles", "queue_free")
	$SonDefaite.play()
	$InterfaceJeu.message_fin()


func incremente_score():
	if not $AndouilleTimer.is_stopped():
		score += 1
		$InterfaceJeu.maj_score(score)
		$SonAndouilleSortie.play()


func _on_AndouilleTimer_timeout():
	# générer une position d'entrée d'une Andouille sur le bord de la zone de jeu
	var andouille_entree_position = get_node("AndouillePath2D/AndPathFollow2D")
	andouille_entree_position.offset = randi()
	# instancier une Andouille dirigée vers l'intérieur de la zone de jeu
	# avec une direction aléatoire et une taille aléatoire
	var andouille = scene_andouille.instance()
	andouille.position = andouille_entree_position.position
	var direction = andouille_entree_position.rotation + PI + rand_range (-PI / 4, PI / 4)
	andouille.rotation = direction
	var echelle = rand_range(0.5, 2.0)
	andouille.scale = Vector2(echelle, echelle)
	add_child(andouille)
	andouille.connect("andouille_sortie", self, "incremente_score")

