extends Area2D

signal collision

export var vitesse = 200 # vitesse de déplacement en pixels par seconde
var taille_ecran
var dead_zone = 0.1
var mouvement = Vector2.ZERO # vecteur de déplacement

func _ready():
	taille_ecran = get_viewport_rect().size

func _process(delta):
	
	# calculer le mouvement et l'orientation de Petit Boudin
	if mouvement.length() > 0:
		mouvement = mouvement.normalized() * vitesse
		rotation = mouvement.angle() + PI / 2
	
	# mettre à jour la position de Petit Boudin
	position += mouvement * delta
	# empêcher Petit Boudin de sortir de la zone de jeu
	position.x = clamp(position.x, 0, taille_ecran.x)
	position.y = clamp(position.y, 0, taille_ecran.y)

func demarrer(pos, rot):
	position = pos
	rotation = rot
	show()
	$PBCollisionShape2D.disabled = false

func _unhandled_input(event):
	if event is InputEventJoypadMotion:
		if event.get_axis() == 0:
			if event.get_axis_value() < -dead_zone:
				mouvement.x = -1
			elif event.get_axis_value() > dead_zone:
				mouvement.x = 1
			else:
				mouvement.x = 0
		
		if event.get_axis() == 1:
			if event.get_axis_value() < -dead_zone:
				mouvement.y = -1
			elif event.get_axis_value() > dead_zone:
				mouvement.y = 1
			else:
				mouvement.y = 0
		
		print(event.as_text())

func _on_PetitBoudin_area_entered(_area):
	hide()
	emit_signal("collision")
	$PBCollisionShape2D.set_deferred("disabled", true)
